regina::NDiscSetSurfaceData< T > Class Template Reference
Normal Surfaces

Stores data of type `T` for every normal disc within a particular normal surface. More...

`#include <surfaces/ndisc.h>`

Inheritance diagram for regina::NDiscSetSurfaceData< T >:

## Public Member Functions

| NDiscSetSurfaceData (const NNormalSurface &surface)
| Creates a new disc set corresponding to the discs of the given normal surface. More...
| NDiscSetSurfaceData (const NNormalSurface &surface, const T &initValue)
| Creates a new disc set corresponding to the discs of the given normal surface. More...
T & | data (const NDiscSpec &disc)
| Retrieves a reference to the data corresponding to the given normal disc. More...
unsigned long | nTets () const
| Returns the number of tetrahedra in the underlying triangulation. More...
unsigned long | nDiscs (unsigned long tetIndex, int type) const
| Determines the number of discs of the given type inside the given tetrahedron. More...
NDiscSetTet & | tetDiscs (unsigned long tetIndex) const
| Returns the specific set of discs living inside the given tetrahedron. More...
NDiscSpec * | adjacentDisc (const NDiscSpec &disc, NPerm4 arc, NPerm4 &adjArc) const
| Determines which normal disc is adjacent to the given normal disc along the given directed normal arc in the surface described by this disc set. More...

## Protected Attributes

NDiscSetTet ** | discSets
| The disc sets corresponding to each tetrahedron. More...
const NTriangulation * | triangulation
| The triangulation in which the normal surface lives. More...

## Detailed Description

### template<class T>
class regina::NDiscSetSurfaceData< T >

Stores data of type `T` for every normal disc within a particular normal surface.

This data is stored using an array of NDiscSetTetData<T> objects, one for each tetrahedron (thus the inherited member function tetDiscs() will return an object of class NDiscSetTetData<T>).

Warning
  This class converts the number of normal discs of a given type from NLargeInteger to `unsigned long`. See the precondition below.

Precondition
  The number of normal discs of a particular type in a particular tetrahedron can be represented by a long integer.
  This class should only be used with embedded normal surfaces.
  Type T has a default constructor and an assignment operator. That is, if `a` and `b` are of type T, then `a` can be declared with no parameters and can then receive the value of `b` using `a=b`.

Python:
  Not present.

## Constructor & Destructor Documentation

template<class T >

regina::NDiscSetSurfaceData< T >::NDiscSetSurfaceData | ( | const NNormalSurface & | surface | ) |

inline

Creates a new disc set corresponding to the discs of the given normal surface.

The data for each disc will remain uninitialised.

Parameters

  surface | the normal surface whose discs we shall use.

template<class T >

regina::NDiscSetSurfaceData< T >::NDiscSetSurfaceData | ( | const NNormalSurface & | surface,
|  | const T & | initValue
| ) |  |

inline

Creates a new disc set corresponding to the discs of the given normal surface.

The data for each disc will be initialised to the given value.

Parameters

  surface | the normal surface whose discs we shall use.
  initValue | the value with which to initialise the data corresponding to each disc.

## Member Function Documentation

NDiscSpec* regina::NDiscSetSurface::adjacentDisc | ( | const NDiscSpec & | disc,
|  | NPerm4 | arc,
|  | NPerm4 & | adjArc
| ) |  | const

inherited

Determines which normal disc is adjacent to the given normal disc along the given directed normal arc in the surface described by this disc set.

A directed normal arc will be specified by a permutation p, where the arc runs around vertex `p[0]` parallel to the directed edge from vertex `p[1]` to `p[2]`.

Parameters

  disc | the given normal disc; this must be a disc in this disc set.
  arc | the given normal arc; this must actually be an arc on the boundary of the given normal disc (although it may run in either direction).
  adjArc | returns the same directed normal arc that was passed, but expressed in terms of the vertices of the adjacent tetrahedron. Any value may be initially passed. If there is no adjacent disc/tetrahedron, this permutation will remain unchanged.

Returns
  the normal disc adjacent to the given disc along the given arc, or 0 if there is no adjacent disc. This disc specifier will be newly created, and it is up to the caller of this routine to dispose of it.

template<class T >

T& regina::NDiscSetSurfaceData< T >::data | ( | const NDiscSpec & | disc | ) |

inline

Retrieves a reference to the data corresponding to the given normal disc.

Parameters

  disc | the disc whose data we require; this must refer to a disc within this disc set.

Returns
  a reference to the data corresponding to the given normal disc.

unsigned long regina::NDiscSetSurface::nDiscs | ( | unsigned long | tetIndex,
|  | int | type
| ) |  | const

inline inherited

Determines the number of discs of the given type inside the given tetrahedron.

Parameters

  tetIndex | the index in the triangulation of the tetrahedron to examine.
  type | the disc type to examine; this should be between 0 and 9 inclusive. Disc types are outlined in the NDiscSpec class notes.

Returns
  the number of discs of the given type inside the given tetrahedron.

unsigned long regina::NDiscSetSurface::nTets | ( |  | ) | const

inline inherited

Returns the number of tetrahedra in the underlying triangulation.

Returns
  the number of tetrahedra.

NDiscSetTet & regina::NDiscSetSurface::tetDiscs | ( | unsigned long | tetIndex | ) | const

inline inherited

Returns the specific set of discs living inside the given tetrahedron.

Parameters

  tetIndex | the index in the triangulation of the given tetrahedron.

Returns
  the set of discs inside the given tetrahedron.

## Member Data Documentation

NDiscSetTet** regina::NDiscSetSurface::discSets

protected inherited

The disc sets corresponding to each tetrahedron.

const NTriangulation* regina::NDiscSetSurface::triangulation

protected inherited

The triangulation in which the normal surface lives.

The documentation for this class was generated from the following file:

- surfaces/ndisc.h

Copyright © 1999-2014, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@debian.org).